
#include <functional>
#include <thread>

#include <boost/smart_ptr.hpp>

void demo_entry(
    boost::shared_ptr<int> &demo_ptr
)
{
}

int main(int argc, char **argv)
{
    auto demo_ptr = boost::make_shared<int>(5);

    std::thread demo_thread(
        demo_entry,
        std::ref(demo_ptr)
    );

    demo_thread.join();

    return 0;
}
